package com.example.system.model;

import lombok.Data;

import javax.persistence.*;

/**
 * 学院实体类，对应数据库中的college_table表。
 */
@Data // Lombok注解，自动生成getters和setters等。
@Entity // JPA注解，标记这是一个实体类。
@Table(name = "college_table") // JPA注解，指定这个实体类对应的表名是college_table。
public class CollegeTable {
    @Id // JPA注解，标记这个字段为表的主键。
    @GeneratedValue(strategy = GenerationType.IDENTITY) // JPA注解，标记主键的生成策略为数据库自增。
    private Long collegeId; // 学院ID，对应college_table表中的college_id字段，为自增长主键。

    private String collegeName; // 学院名称，对应college_table表中的college_name字段。
}
