package com.example.system.model;

import lombok.Getter;

import javax.persistence.*;

@Getter
@Entity
@Table(name = "information_table")
public class InformationTable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "profile_id")
    private Long profileId;

    @Column(name = "user_id")
    private Long userId;

    @Column(name = "competition_id")
    private Long competitionId;

    @Column(name = "personal_info", columnDefinition = "TEXT")
    private String personalInfo;

    @Column(name = "related_data", columnDefinition = "TEXT")
    private String relatedData;

    // Constructors, Getters, and Setters

    public InformationTable() {
    }

    public InformationTable(Long userId, Long competitionId, String personalInfo, String relatedData) {
        this.userId = userId;
        this.competitionId = competitionId;
        this.personalInfo = personalInfo;
        this.relatedData = relatedData;
    }

    public void setProfileId(Long profileId) {
        this.profileId = profileId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public void setCompetitionId(Long competitionId) {
        this.competitionId = competitionId;
    }

    public void setPersonalInfo(String personalInfo) {
        this.personalInfo = personalInfo;
    }

    public void setRelatedData(String relatedData) {
        this.relatedData = relatedData;
    }
}