package com.example.system.repository;

import com.example.system.model.CompetitionTable;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;

/**
 * 竞赛信息的JPA仓库接口，提供对竞赛信息的CRUD操作及模糊搜索功能。
 */
public interface CompetitionRepository extends JpaRepository<CompetitionTable, Long> {
    // 仅根据competitionName进行模糊搜索
    List<CompetitionTable> findByCompetitionNameContaining(String competitionName);
}