import request from '../utils/axios';

// 登录接口
export const login = data => request.post('/auth/login', data);

// 获取验证码接口
export const getAuthCode = () => request.get('/auth/code');

// 获取用户数据接口
export const getUserData = () => request.get('/get_user');

/**
 * 用户相关接口
 */
export const getUserList = params => request.get('/user/list', { params });
export const addUser = (type, data) => request.post('/user/add', { type, data });
export const importUser = (type, data) => request.post('/user/import', { type, data });
export const deleteUser = (type, data) => request.delete('/user/delete', { data: { type, data } });
export const updateUser = (type, data) => request.put('/user/update', { type, data });
export const updatePassword = data => request.patch('/user/password', data);
export const resetPassword = data => request.put('/user/reset', data);

/**
 * 赛事相关接口
 */
export const getRaceList = params => request.get('/race/list', { params });
export const addRace = data => request.post('/race/add', data);
export const updateRace = data => request.put('/race/update', data);
export const deleteRace = data => request.delete('/race/delete', { data });

/**
 * 参赛记录相关接口
 */
export const getRecordList = params => request.get('/record/list', { params });
export const addRecord = data => request.post('/record/add', data);
export const updateRecord = data => request.patch('/record/update', data);
export const deleteRecord = data => request.delete('/record/delete', { data });

/**
 * 权限相关接口
 */
export const getPermissions = params => request.get('/permission/list', { params });
export const addPermission = data => request.post('/permission/add', data);
export const updatePermission = data => request.post('/permission/update', data);
export const deletePermission = data => request.delete('/permission/delete', { data });

/**
 * 角色相关接口
 */
export const getRoles = params => request.get('/role/list', { params });
export const addRole = data => request.post('/role/add', data);
export const updateRole = data => request.post('/role/update', data);
export const deleteRole = data => request.delete('/role/delete', { data });
export const grantRole = data => request.post('/role/grant', data);

// 学生登录
// export const Stulogin = params => request.get('/student/login', { params });
